<?xml version='1.0' encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform' version='1.0'>  
<xsl:output method="text" encoding="ISO-8859-1" />
<xsl:strip-space elements="dir file source header tree" />
<xsl:key name="type" match="node()" use="node()" />

<xsl:template match="file|source|header">
 <xsl:param name = "path" /> 
# Begin Source File

SOURCE=.<xsl:value-of select="$path" />\<xsl:value-of select="@name" /><xsl:value-of select="@ext" />
# End Source File 
</xsl:template>

<xsl:template match="dir|tree" name="dir">
 <xsl:param name = "path" /> 
 <xsl:param name = "type" /> 
 <xsl:param name = "custom_name" /> 
 <xsl:param name = "fake" /> 
 
 <xsl:variable name="path_name">
   <xsl:value-of select="$path" />
   <xsl:if test="count(@name) != 0">\</xsl:if>
   <xsl:value-of select="@name" />
 </xsl:variable>

<xsl:if test="$fake = ''">
# PROP Default_Filter "" 
# Begin Group "<xsl:if test="count(@name) != 0"><xsl:value-of select="@name" /><text> - </text></xsl:if><xsl:value-of select="$custom_name" />"
</xsl:if>
 <xsl:apply-templates select="dir[.//*[name(.)=$type]]">
  <xsl:with-param name="path" select="$path_name" />
  <xsl:with-param name="type" select="$type" />
  <xsl:with-param name="custom_name" select="$custom_name" />
 </xsl:apply-templates>
 <xsl:apply-templates select="*[name(.)=$type]">
  <xsl:with-param name="path" select="$path_name" />
 </xsl:apply-templates>
<xsl:if test="$fake = ''">
# End Group
</xsl:if>
</xsl:template>

<!--
  Well, the first run of Root seem to fail : 
   Root get the arguments, but fails to transmit them to 
    the element tree...
   Should be a problem of the parser, this "fake" is a workaround.
-->
<xsl:template match="Root">
 <xsl:param name="fake" />

<xsl:apply-templates select="document(@tree)/tree">
  <xsl:with-param name="type" select="@types" />
  <xsl:with-param name="custom_name" select="@name" />
  <xsl:with-param name="path" select="@basepath" />
  <xsl:with-param name="fake" select="$fake" />
</xsl:apply-templates>

</xsl:template>


<xsl:template match="Makefile">
# Microsoft Developer Studio Project File - Name="<xsl:value-of select="ProjectName" />" - Package Owner=&lt;4&gt;
# Microsoft Developer Studio Generated Build File, Format Version 6.00
# ** DO NOT EDIT **

# TARGTYPE <xsl:value-of select="TargetName" />

<xsl:variable name="curCfg"><xsl:value-of select="ProjectName" /> - Win32 <xsl:value-of select="Targets/Current/@name" /></xsl:variable>
CFG=<xsl:value-of select="$curCfg" />
!MESSAGE This is not a valid makefile. To build this project using NMAKE,
!MESSAGE use the Export Makefile command and run
!MESSAGE 
!MESSAGE NMAKE /f "<xsl:value-of select="ProjectName" />.mak".
!MESSAGE 
!MESSAGE You can specify a configuration when running NMAKE
!MESSAGE by defining the macro CFG on the command line. For example:
!MESSAGE 
!MESSAGE NMAKE /f "<xsl:value-of select="ProjectName" />.mak" CFG="<xsl:value-of select="$curCfg" />"
!MESSAGE 
!MESSAGE Possible choices for configuration are:
!MESSAGE 
<xsl:for-each select="Targets/Target">!MESSAGE "<xsl:value-of select="//ProjectName" /> - Win32 <xsl:value-of select="@name" />" (based on "Win32 (x86) Application")
</xsl:for-each>
!MESSAGE 

# Begin Project
# PROP AllowPerConfigDependencies 0
# PROP Scc_ProjName ""
# PROP Scc_LocalPath ""
CPP=cl.exe
MTL=midl.exe
RSC=rc.exe

<xsl:for-each select="Targets/Target">

<xsl:choose>
 <xsl:when test="position( ) = 1">
!IF  "$(CFG)" == "<xsl:value-of select="//ProjectName" /> - Win32 <xsl:value-of select="@name" />"
 </xsl:when>
 <xsl:otherwise>
!ELSEIF  "$(CFG)" == "<xsl:value-of select="//ProjectName" /> - Win32 <xsl:value-of select="@name" />"
 </xsl:otherwise>
</xsl:choose>

# PROP BASE Use_MFC 0
# PROP BASE Use_Debug_Libraries <xsl:value-of select="Debug" />
# PROP BASE Output_Dir "<xsl:value-of select="OutputDir" />"
# PROP BASE Intermediate_Dir "<xsl:value-of select="OutputDir" />"
# PROP BASE Target_Dir ""
# PROP Use_MFC 0
# PROP Use_Debug_Libraries <xsl:value-of select="Debug" />
# PROP Output_Dir "<xsl:value-of select="OutputDir" />"
# PROP Intermediate_Dir "<xsl:value-of select="OutputDir" />"
# PROP Target_Dir ""
# ADD BASE CPP <xsl:value-of select="CppOptions/GeneralOptions" /> <xsl:value-of select="CppOptions/Defines" />
# ADD CPP <xsl:value-of select="CppOptions/GeneralOptions" /> <xsl:value-of select="CppOptions/Defines" />
# ADD BASE MTL /nologo /D "NDEBUG" /mktyplib203 /win32
# ADD MTL /nologo /D "NDEBUG" /mktyplib203 /win32
# ADD BASE RSC /l 0x40c /d "NDEBUG"
# ADD RSC /l 0x40c /d "NDEBUG"
BSC32=bscmake.exe
# ADD BASE BSC32 /nologo
# ADD BSC32 /nologo
LINK32=link.exe
# ADD BASE LINK32 <xsl:value-of select="LinkOptions/GeneralOptions" /> <xsl:value-of select="LinkOptions/Librairies" />
# ADD LINK32 <xsl:value-of select="LinkOptions/GeneralOptions" /> <xsl:value-of select="LinkOptions/Librairies" />
<xsl:text>

</xsl:text>
</xsl:for-each>

!ENDIF 

# Begin Target
<xsl:for-each select="Targets/Target"># Name  "<xsl:value-of select="//ProjectName" /> - Win32 <xsl:value-of select="@name" />"
</xsl:for-each>

<xsl:apply-templates select="Roots/Root[1]">
 <xsl:with-param name="fake">fake</xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="Roots" />

# End Target
# End Project

</xsl:template>

</xsl:stylesheet>